package com.ruoyi.system.controller;

import org.springframework.web.bind.annotation.DeleteMapping;
import org.springframework.web.bind.annotation.PutMapping;
import org.springframework.web.bind.annotation.RequestBody;
import com.ruoyi.common.core.web.domain.AjaxResult;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.PostMapping;
import com.ruoyi.common.log.enums.BusinessType;
import com.ruoyi.common.log.annotation.Log;
import com.ruoyi.common.core.utils.poi.ExcelUtil;
import javax.servlet.http.HttpServletResponse;
import org.springframework.web.bind.annotation.GetMapping;
import com.ruoyi.common.security.annotation.RequiresPermissions;
import java.util.List;
import com.ruoyi.common.core.web.page.TableDataInfo;
import com.ruoyi.system.domain.SnTemplatePerms;
import org.springframework.beans.factory.annotation.Autowired;
import com.ruoyi.system.service.ISnTemplatePermsService;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;
import com.ruoyi.common.core.web.controller.BaseController;

@RestController
@RequestMapping({ "/SnTemplatePerms" })
public class SnTemplatePermsController extends BaseController
{
    @Autowired
    private ISnTemplatePermsService snTemplatePermsService;
    
    @RequiresPermissions({ "system:SnTemplatePerms:list" })
    @GetMapping({ "/list" })
    public TableDataInfo list(final SnTemplatePerms snTemplatePerms) {
        this.startPage();
        final List<SnTemplatePerms> list = this.snTemplatePermsService.selectSnTemplatePermsList(snTemplatePerms);
        return this.getDataTable((List)list);
    }
    
    @RequiresPermissions({ "system:SnTemplatePerms:export" })
    @Log(title = "模板权限", businessType = BusinessType.EXPORT)
    @PostMapping({ "/export" })
    public void export(final HttpServletResponse response, final SnTemplatePerms snTemplatePerms) {
        final List<SnTemplatePerms> list = this.snTemplatePermsService.selectSnTemplatePermsList(snTemplatePerms);
        final ExcelUtil<SnTemplatePerms> util = (ExcelUtil<SnTemplatePerms>)new ExcelUtil((Class)SnTemplatePerms.class);
        util.exportExcel(response, (List)list, "模板权限数据");
    }
    
    @RequiresPermissions({ "system:SnTemplatePerms:query" })
    @GetMapping({ "/{id}" })
    public AjaxResult getInfo(@PathVariable("id") final Long id) {
        return this.success((Object)this.snTemplatePermsService.selectSnTemplatePermsById(id));
    }
    
    @RequiresPermissions({ "system:SnTemplatePerms:add" })
    @Log(title = "模板权限", businessType = BusinessType.INSERT)
    @PostMapping
    public AjaxResult add(@RequestBody final SnTemplatePerms snTemplatePerms) {
        return this.toAjax(this.snTemplatePermsService.insertSnTemplatePerms(snTemplatePerms));
    }
    
    @RequiresPermissions({ "system:SnTemplatePerms:edit" })
    @Log(title = "模板权限", businessType = BusinessType.UPDATE)
    @PutMapping
    public AjaxResult edit(@RequestBody final SnTemplatePerms snTemplatePerms) {
        return this.toAjax(this.snTemplatePermsService.updateSnTemplatePerms(snTemplatePerms));
    }
    
    @RequiresPermissions({ "system:SnTemplatePerms:remove" })
    @Log(title = "模板权限", businessType = BusinessType.DELETE)
    @DeleteMapping({ "/{ids}" })
    public AjaxResult remove(@PathVariable final Long[] ids) {
        return this.toAjax(this.snTemplatePermsService.deleteSnTemplatePermsByIds(ids));
    }
}
